package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    String[][] board = new String[3][3];

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {

        return this.board[value];
    }

    public String[] getColumn(Integer value) {
        String[] result = new String[3];
        for (int i = 0; i < 3; i++) {
            result[i] = this.board[i][value];
        }
        return result;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {

        String[] row = getRow(rowIndex);
        if(row[0].equals(row[1]) && row[0].equals(row[2]))
            return true;

        return false;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {

        String[] col = getColumn(columnIndex);
        if(col[0].equals(col[1]) && col[0].equals(col[2]))
            return true;

        return false;
    }

    public Boolean isDiagonalLeftHomogeneous() {

        String[] diagonal = {this.board[0][0], this.board[1][1], this.board[2][2]};
        if (diagonal[0].equals(diagonal[1]) && diagonal[0].equals(diagonal[2]))
            return true;
        return false;
    }

    public Boolean isDiagonalRightHomogeneous() {

        String[] diagonal = {this.board[0][2], this.board[1][1], this.board[2][0]};
        if (diagonal[0].equals(diagonal[1]) && diagonal[0].equals(diagonal[2]))
            return true;
        return false;
    }



    public String getWinner() {

        if(isDiagonalLeftHomogeneous())
            return getRow(0)[0];

        if(isDiagonalRightHomogeneous())
            return getRow(0)[2];

        for (int i = 0; i < 3; i++) {
            if(isRowHomogenous(i))
                return getRow(i)[0];
            if(isColumnHomogeneous(i))
                return getColumn(i)[0];
        }

        return null;
    }
}
