package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author leon on 10/12/2018.
 */
public class Student {

    Map<Lab, LabStatus> map = new TreeMap<>();

    public Student() {

    }

    public Student(Map<Lab, LabStatus> map) {

        this.map = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {
        try {
        if(!map.containsKey(lab)) {
            throw new UnsupportedOperationException();
        } } catch (NullPointerException e) {
            throw new UnsupportedOperationException();
        }

        map.put(lab, labStatus);

    }


    public void forkLab(Lab lab) {

        map.put(lab, LabStatus.PENDING);

    }

    public LabStatus getLabStatus(String labName) {
            return map.get(findLabByName(labName));
    }

    private Lab findLabByName(String labName) {
        for(Lab l: map.keySet()) {
            if (l.getName().equals(labName))
                return l;
        }
        return null;
    }

    @Override
    public String toString() {

        String result = "";

        for(Lab lab : map.keySet()) {
            result += lab.getName() + " > " + map.get(lab) + "\n";
        }
        return result.trim();
    }
}
