package rocks.zipcode.io.quiz3.generics;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {
    private final SomeType[] array;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {

        for(SomeType item: array) {
            Integer occ = getNumberOfOccurrences(item);
            if(occ % 2 != 0) {
                return item;
            }
        }
        return null;
    }

    public SomeType findEvenOccurringValue() {

        for(SomeType item: array) {
            Integer occ = getNumberOfOccurrences(item);
            if(occ % 2 == 0) {
                return item;
            }
        }
        return null;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {

        Integer count = 0;

        for(SomeType item : array) {
            if(item.equals(valueToEvaluate)) {
                count++;
            }
        }

        return count;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {

        return (SomeType[]) Arrays.stream(array)
                .filter((Predicate<? super SomeType>) predicate)
                .toArray();
    }
}
